/*
*    configrec.c
*    User interface code for NCSA Telnet for the Macintosh
*	 by Gaige B. Paulsen
****************************************************************************
*                                                                          *
*      Uses	:															   *
*      TCP/IP kernel for NCSA Telnet                                       *
*      by Tim Krauskopf                                                    *
*	   with Macintosh code by Gaige B. Paulsen						  	   *
*                                                                          *
*      National Center for Supercomputing Applications                     *
*      152 Computing Applications Building                                 *
*      605 E. Springfield Ave.                                             *
*      Champaign, IL  61820                                                *
*                                                                          *
*                                                                          *
****************************************************************************
*
*	Configuration structure.	
*
*	Included by:
*		config.c
*		menu.c
*		maclook.c
*/

typedef struct {
	int						/* BYU */
	    connectionType,		/* BYU serial - 0 = network, 1 = serial, 2 = SLIP */
	    ftpstate,			/* BYU - 0 = Telnet session, 1 = Ftp session */
		bsdel,				/* BYU - True if Backspace should remap to delete */
		tektype,			/* 0 for 4014, 1 for 4105 */
		width,				/* Width of screen in columns 80/132 */
		clearsave,			/* True if should save cleared screen lines */
		tekclear,			/* True if clear on ESC-FF, False if new window */
		halfdup,			/* True if send immediate and echo arrows in Telnet NO ECHO mode */
		crmap,				/* True if CR-NUL */
		vtwrap,				/* True if Terminal WRAP setting is enabled by default */
		nlines,				/* number of usable lines in the window */
		port,				/* what TCP port number to connect to, TELNET == 23 */
		lineAllow,			/* allow linemode? */
		eightbit,			/* eight bit font? */				/* BYU 2.4.9 */
		scrollback;			/* # of lines of scrollback */
	short font;				/* Font ID */
	short ftpwind;			/* is it an ftp window? */
	int fsize;				/* Font size */
	unsigned int 
		red[4],				/* Colors: 1-NF, 2-NB, 3-BF, 4-BB */
		green[4],
		blue[4];
	char 
		TELstop,			/* Character for scrolling to stop */
		TELgo,				/* Character for scrolling to go */
		TELip,				/* Character for interrupt process */
		*name,				/* Window name */
		 *machine;			/* Machine Name */
	Rect window,			/* Window Rectangle (USER) */
		 stdwindow;			/* Window Rectangle (Standard */
	} ConfigRec;


