/*
 * File: EtherTalk.h - equates for the Ethernet driver 
 *
 */

/* Control codes */  

#define	ESetGeneral 	253		/* Set "general" mode */
#define	EGetInfo		252             	/* Get info */
#define	ERdCancel		251             	/* Cancel read */
#define	ERead			250             	/* Read */
#define	EWrite			249             	/* Write */
#define	EDetachPH		248             	/* Detach protocol handler */
#define	EAttachPH		247             	/* Attach protocol handler */

#define FirstENET		EAttachPH       	/* First ENET command */
#define LastENET		ESetGeneral       	/* Last ENET command */

/* ENET queue element standard structure:  arguments passed in the CSParam area */

#define EProtType	  	CSParam		/* Offset to protocol type code */

#define EHandler 		EProtType+2 	/* Offset to protocol handler */
#define EWDSPointer 	EHandler		/* WDS pointer (EWrite) */
#define EBuffPtr		EHandler		/* Buffer pointer (ERead,EGetInfo) */
#define EKillQEl		EHandler		/* QEl pointer (ERdCancel) */

#define EBuffSize		EBuffPtr+4	/* Buffer size (ERead,EGetInfo) */
#define EDataSize		EBuffSize+2	/* Actual data size (Eread) */


/*_____________________________________ */
/*                                      */
/* Ethernet packet header				*/
/*_____________________________________ */

#define	EDestAddr		0		/* Offset to destination address */
#define	ESrcAddr		6		/* Offset to source address */
#define	EType			12		/* Offset to data link type */
#define	EHdrSize		14		/* Ethernet header size */

#define	EMinDataSz		46		/* Minimum data size */
#define	EMaxDataSz		1500	/* Maximum data size */
#define	EAddrSz			6		
#define	MAddrSz			8		

typedef struct EtParam {
char	*qLink;
short	 qType,
		 ioTrap;
char	*ioCmdAddr,
		*ioCompletion;
short	 ioResult;
char	*ioNamePtr;
short	 ioVRefNum,
		 ioCRefNum,
		 csCode;
unsigned short
		 protocol;
void	*address;
short	 bufsize;
short	 datsize;
	} EtParam;


