/*
*    prefs.h
*	 by Gaige B. Paulsen
****************************************************************************
*	Part of NCSA Telnet for the Macintosh								   *
*                                                                          *
*      Uses	:															   *
*      TCP/IP kernel for NCSA Telnet                                       *
*      by Tim Krauskopf                                                    *
*	   with Macintosh code by Gaige B. Paulsen						  	   *
*                                                                          *
*      National Center for Supercomputing Applications                     *
*      152 Computing Applications Building                                 *
*      605 E. Springfield Ave.                                             *
*      Champaign, IL  61820                                                *
*                                                                          *
*                                                                          *
****************************************************************************
*
*    Preferences structures and initialization data.
*
*	Included by:
*		prefs.c
*		maclook.c
*/


/*
 * Preferences record for NCSA Telnet 
 */

#define PREF_Version		7	/* BYU 2.4.11 - was 5 */	/* BYU 2.4.18 - was 6 */

typedef struct {
	short Version;			/* Preferences Record Version Information */
	short CTthresh;			/* Copy Table Threshold */
	short cmdKeys;			/* Command Keys on? */
	short MacBinary;			/* MacBinary on by default? */
	short MacBReset;			/* MacBinary state resets on connect? */
	short optKeys;			/* Enable the Option key translations */
	short dontclose;			/* Closed connections don't go away */
	short mapTilde;			/* Mapping the Tilde, Mapping the Tilde, .... */
	short stag;				/* staggered windows */
	short cursorBlink;		/* BYU 2.4.11 - blink the cursor? */
	short cursorType;		/* BYU 2.4.11 - 0 = block, 1 = underscore, 2 = vertical line */
	short systemKCHR;		/* BYU 2.4.18 */
	} NCSAPrefs;

#ifdef PREFMASTER
NCSAPrefs	Prefs = { PREF_Version, 2, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0};	/* BYU 2.4.18 */
int PrefLength[] =
			{ 0,					/* Prefs 0 didn't exist.... */
			 10,					/* Prefs 1 didn't have optKeys */
			 12,					/* Prefs 2 didn't have dontclose */
			 14,					/* Prefs 3 didn't have mapTilde */
			 16,	/* BYU 2.4.11 - staggered windows */	
			 18,	/* BYU 2.4.11 - ? */
			 22,	/* BYU 2.4.11 - +4 bytes: blinking cursor and different cursor types */
			 24		/* BYU 2.4.18 - +2 bytes: choice of application or system KCHR */
			};
#else
extern NCSAPrefs Prefs;
extern int PrefLength[];
#endif

extern void PromptPrefs
  (
	void
  );

extern int GetPrefs
  (
	void
  );
