/*
 *
 *      Virtual Graphics Kernel Real Graphics Interface
 *                          (rg2.c)
 *
 *   National Center for Supercomputing Applications
 *      by Gaige B. Paulsen
 *
 *    This file contains the macintosh real screen calls for the NCSA
 *  Virtual Graphics Kernel.
 *
 *	Following are the Per Device calls:
 *
 *      RGsetdevice( n)             - Use device n for future output
 * wn = RGnewwindow( name, x1,y1,x2,y2)
 *									- create a new window 
 * wn = RGsubwindow( wn,x1,y1,x2,y2)- create a new subwindow in window wn
 *      RGsetwindow( wn)     		- Set the current window to wn
 *      RGdestroy( wn)				- Destroy window wn
 * ok = RGupdate( wind)        		- Perform graphics update on window n
 * wn = RGfindwn( wind)      		- Get the wn from the window pointer
 * ok = RGclick( wind)            	- Handle click in the window 
 *
 *
 *      Version Date    Notes
 *      ------- ------  ---------------------------------------------------
 *		0.5 	880912	Initial Coding -GBP
 */
 
#include <Windows.h>

#include "vrrgmac.h"

#define RG_MAC	1					/* For Now */

void RGsetdevice
  (
	int n
  )
{
	if (n==RG_MAC)
		MacRGsetdevice();
}

int RGnewwindow( name, x1,y1,x2,y2)
char *name;
int x1,y1,x2,y2;
{
	return( MacRGnewwindow( name, x1, y1, x2, y2));
}

int RGsubwindow( wn,x1,y1,x2,y2)
	int wn,x1,y1,x2,y2;
  {
#pragma unused(x1, y1, x2, y2)
	return(MacRGsubwindow( wn));
  }

RGsetwindow( wn)
int wn;
{
	MacRGsetwindow( wn);
}

void RGdestroy
  (
	int wn
  )
{
	MacRGdestroy(wn);
}

#if 0						/* BYU LSC */
int RGupdate
  (
	WindowPtr wind
  )
{
	return
		MacRGupdate(wind);
}
#endif						/* BYU LSC */

int RGfindwn( wind)
	long wind;
  {
#pragma unused(wind)
	return 0;
  }

int RGclick( wind)
	long wind;
  {
#pragma unused(wind)
	return 0;
  }

