#ifdef lint
static char *SCCSid = "%W%	(NCSA)	%G%";
#endif

/*

rgmp.c by Gaige B. Paulsen
  spawned from rgp.c by Aaron Contorer for NCSA
Copyright 1987, board of trustees, University of Illinois

Routines for Macintosh Picture output.  Only one Real device is available

*/

/* 
 *	Include files 
 */

#include <stdio.h>

#include <Controls.h>
#include <OSutils.h>
#include <Packages.h>
#include <Quickdraw.h>
#include <Windows.h>


#define TRUE 1
#define FALSE 0
#define MAXWIND 20
#define INXMAX 4096
#define INYMAX 4096

char *MPname = "Macintosh PICTURE output";
char RGMPbusy; /* is device already in use */
int RGMPwidth, RGMPheight, RGMPxoffset=0, RGMPyoffset=0;
int RGMPcolor[]=
	{ 30,			/* black */
	  33,			/* white */
	  205,			/* red */
	  341,			/* green */
	  409,			/* blue */
	  273,			/* cyan */
	  137,			/* magenta */
	  69			/* yellow */
	  };

RGMPcharmode(w,rotation,size)
  {
#pragma unused(w, rotation, size)
  }

RGMPpagedone()
  {
  }

RGMPpencolor(w, color)
{
#pragma unused(w)
	ForeColor( (long) RGMPcolor[color] );
}

RGMPdataline()
  {
  }

RGMPclrscr()
  {
  }

RGMPshowcur()
  {
  }

RGMPlockcur()
  {
  }

RGMPhidecur()
  {
  }

RGMPbell(w)
  {
#pragma unused(w)
  }

RGMPuncover(w)
  {
#pragma unused(w)
  }

RGMPinfo(w,v,a,b,c,d)
int w,a,b,c,d,v;
  {
#pragma unused(w, v, a, b, c, d)
  }

RGMPgmode()
  {
  }

RGMPtmode()
  {
  }

char *RGMPdevname() {
	return(MPname);
}

RGMPinit()
{
	RGMPbusy=0;

/*	RGMPwidth=4096;
	RGMPheight=4096; */
	RGMPxoffset=0;
	RGMPyoffset=0;
}

RGMPnewwin()
{

	RGMPbusy=1;

/*	RGMPwidth=4096;
	RGMPheight=4096;	 */
	RGMPxoffset=0;
	RGMPyoffset=0;

	return(0);
}

RGMPclose(w)
  {
#pragma unused(w)
	RGMPbusy=0;
  }

RGMPpoint(w,x,y)
  {
#pragma unused(w)
	MoveTo(x,y);
	LineTo(x,y);
}

RGMPdrawline(w,x0,y0,x1,y1)
int w,x0,y0,x1,y1;
  {
#pragma unused(w)
	x0 = RGMPxoffset + (int) ((long) x0 * RGMPwidth / INXMAX);
	y0 = RGMPyoffset + RGMPheight - (int) ((long) y0 * RGMPheight / INYMAX);
	x1 = RGMPxoffset + (int) ((long) x1 * RGMPwidth/INXMAX);
	y1 = RGMPyoffset + RGMPheight - (int) ((long) y1 * RGMPheight / INYMAX);

	MoveTo(x0,y0);
	LineTo(x1,y1);
  }

int RGMPsize
  (
	Rect *incoming
  )
{
	RGMPheight= incoming->bottom-incoming->top;
	RGMPwidth = incoming->right - incoming->left;
	RGMPyoffset= incoming->top;
	RGMPxoffset= incoming->left; 

	return(0);
}
