/*	%W%	(NCSA)	%G%		*/

/* output devices */

#define MAXRG 4

#define DEVNULL 0
#define MAC 1
#define HP 2
#define MP 3

#define MAXWIND 20
#define WINXMAX 4095
#define WINYMAX 3139
#define INXMAX 4096
#define INYMAX 4096


typedef struct {
	int 
	(*init)(), (*point)(), (*drawline)(), (*newwin)(),
	(*clrscr)(), (*pagedone)(), (*dataline)(), (*pencolor)(),
	(*charmode)(), (*showcur)(), (*lockcur)(), (*hidecur)(),
	(*close)(), (*uncover)(), (*info)(),
	(*gmode)(), (*tmode)(), (*gin)();
	char *(*devname)();
	int (*bell)();
} RGLINK;

#define PREDCOUNT 50

extern int 
	RG0init(), RG0point(), RG0drawline(), RG0newwin(),
	RG0clrscr(), RG0pagedone(), RG0dataline(), RG0pencolor(),
	RG0charmode(), RG0showcur(), RG0lockcur(), RG0hidecur(),
	RG0close(), RG0uncover(), RG0info(),
	RG0gmode(), RG0tmode(), RG0bell(),

	RGMinit(), RGMpoint(), RGMdrawline(), RGMnewwin(),
	RGMclrscr(), RGMpagedone(), RGMdataline(), RGMpencolor(),
	RGMcharmode(), RGMshowcur(), RGMlockcur(), RGMhidecur(),
	RGMclose(), RGMuncover(), RGMinfo(),
	RGMgmode(), RGMtmode(), RGMgin(), RGMbell(),

	RGMPinit(), RGMPpoint(), RGMPdrawline(), RGMPnewwin(),
	RGMPclrscr(), RGMPpagedone(), RGMPdataline(), RGMPpencolor(),
	RGMPcharmode(), RGMPshowcur(), RGMPlockcur(), RGMPhidecur(),
	RGMPclose(), RGMPuncover(), RGMPinfo(),
	RGMPgmode(), RGMPtmode(), RGMPbell()
#ifdef HP_USED

	,RGHPinit(), RGHPpoint(), RGHPdrawline(), RGHPnewwin(),
	RGHPclrscr(), RGHPpagedone(), RGHPdataline(), RGHPpencolor(),
	RGHPcharmode(), RGHPshowcur(), RGHPlockcur(), RGHPhidecur(),
	RGHPclose(), RGHPuncover(), RGHPinfo(),
	RGHPgmode(), RGHPtmode(), RGHPbell(), 
#endif HP_USED
;

extern char
	*RGMdevname(), *RG0devname(), *RGMPdevname()
#ifdef HP_USED
	,*RGHPdevname()
#endif HP_USED
	;

extern int donothing	/* BYU LSC */
  (
	void
  );

static RGLINK RG[MAXRG] = {		/* BYU LSC */
	RG0init,     RG0point,    RG0drawline, RG0newwin,
	RG0clrscr,   RG0pagedone, RG0dataline, RG0pencolor,
	RG0charmode, RG0showcur,  RG0lockcur,  RG0hidecur,
	RG0close,    RG0uncover,  RG0info,     RG0gmode,    
	RG0tmode,    donothing,   RG0devname,  RG0bell,

	RGMinit,     RGMpoint,    RGMdrawline, RGMnewwin,
	RGMclrscr,   RGMpagedone, RGMdataline, RGMpencolor,
	RGMcharmode, RGMshowcur,  RGMlockcur,  RGMhidecur,
	RGMclose,    RGMuncover,  RGMinfo,     RGMgmode,    
	RGMtmode,    RGMgin,      RGMdevname,  RGMbell,

#ifdef RGHP_USED
	RGHPinit,     RGHPpoint,    RGHPdrawline, RGHPnewwin,
	RGHPclrscr,   RGHPpagedone, RGHPdataline, RGHPpencolor,
	RGHPcharmode, RGHPshowcur,  RGHPlockcur,  RGHPhidecur,
	RGHPclose,    RGHPuncover,  RGHPinfo,     RGHPgmode, 
	RGHPtmode,    donothing,    RGHPdevname,  RGHPbell,
#else
	RG0init,     RG0point,    RG0drawline, RG0newwin,
	RG0clrscr,   RG0pagedone, RG0dataline, RG0pencolor,
	RG0charmode, RG0showcur,  RG0lockcur,  RG0hidecur,
	RG0close,    RG0uncover,  RG0info,     RG0gmode, 
	RG0tmode,    donothing,   RG0devname,  RG0bell,
#endif

	RGMPinit,     RGMPpoint,    RGMPdrawline, RGMPnewwin,
	RGMPclrscr,   RGMPpagedone, RGMPdataline, RGMPpencolor,
	RGMPcharmode, RGMPshowcur,  RGMPlockcur,  RGMPhidecur,
	RGMPclose,    RGMPuncover,  RGMPinfo,     RGMPgmode, 
	RGMPtmode,    donothing,    RGMPdevname,  RGMPbell

};

extern void VGstopred
  (
	int vw
  );

extern void VGpage
  (
	int vw
  );

extern int VGpred
  (
	int vw,
	int dest
  );

extern void VGzoom
  (
	int vw,
	int x0,
	int y0,
	int x1,
	int y1
  );

extern void VGgindata
  (
	int vw,
	int x,
	int y,
	char c,
	char *a
  );

extern int VGnewwin
  (
	int device, /* number of RG device to use */
  	int	theVS
  );

extern void VGzcpy
  (
	int src,
	int dest
  );

extern void VGredraw
  (
	int vw,
	int dest
  );

extern void VGclose
  (
	int vw
  );

extern void VGinit
  (
	void
  );

extern void VGgiveinfo
  (
	int vw
  );

extern int VGwrite
  (
	int vw,
	char *data,
	int count
  );
