/*
 *		%W%	(NCSA)	%G%
 *
 *		MacLook Window Management Data Structure Definition
 *
 *
 */

#include <Controls.h>

#define MAXFTP	128			/* BYU mod */
#define	MAXKB	256			/* BYU mod */

#define TYPE_I_ON_CLOSE	1	/* BYU mod */
#define CAPTURE_DATA	2	/* BYU mod */
#define MGET_STATE		4	/* BYU LSC */
#define MPUT_STATE		8	/* BYU LSC */
#define PASTE_IN_PROGRESS	0x4000 /* BYU LSC */

struct WindRec {
	short	vs,		/* virtual screen number */					/* BYU 2.4.15 */
 	 maxscroll,		/* Requested amount of scroll back */
	   ESclear,		/* BYU mod - will Clear Screen really clear screen? */
	  ESscroll,		/* will Clear Screen Save Lines? */
		  naws,		/* NCSA: will negotiate NAWS */
		active,		/* is window active? (ie on screen?) */
	    corpse,		/* is the window a corpse? */
	 lineAllow,		/* allow linemode? */
	  eightbit,		/* eight bit font displayed (false is seven bit display */	/* BYU 2.4.9 */
		  Isga,		/* I am supressing go ahead */
		  Usga,		/* You are supressing go ahead */
		Ittype,		/* I am sending terminal type negotiations.. */
		  echo,		/* NOTE: this is backwards - I am echoing your chars */
		  wrap,		/* whether vtwrap is set or not for this screen */
connectionType,		/* BYU serial - 0 = network, 1 = serial/SLIP */
		  port,		/* TCP/IP port number */
	   portNum,		/* port number from the application save set */
	   ftpport,		/* BYU mod - FTP port number */
	  ftpstate,		/* BYU mod - Telnet session = 0, Ftp session != 0 */
	  ftpnext,		/* BYU mod - Next ftpstate after waiting for response from "PORT" */
		 bsdel,		/* backspace or delete is default */
	 termstate,		/* Emulation State (-1 is none, 0 is VT100) */
	  telstate,		/* Telnet State */
	  	timing,		/* True if waiting for timing mark */
	   substat,		/* Telnet Subnegot. State */
		  xfer,		/* File X-fer status */
	  curgraph,		/* Associated Tek drawing */
	   enabled,		/* Are we currently enabled for receive? */
	  	outlen,		/* Length of Paste Buffer remaining to be sent */
		 kblen,		/* Pointer to next char in buffer to be used */
	  tekclear,		/* Does tektronix (1) clear screen or (0) add window */
	     width,		/* Width we started with */
	   halfdup,		/* If true then half-duplex mode */
	   tektype,		
	     crmap,		/* BYU mod - CR's second byte is ... */
   capturesize,		/* BYU mod - ftp client size of captured data */
   clientflags;		/* BYU mod - boolean flags for ftp client */

long   incount,		/* BYU LSC - Count of bytes into this port */
      outcount;		/* BYU LSC - Count of bytes out this port */

char     *name,		/* Name of session */
	  *machine,		/* Name of machine */
	   *outptr,		/* Pointer to next char to send */
	 **outhand;		/* Handle to text from the Paste */
	short rows,		/* handshaking */
			col,
		lmflag,		/* are we in line-mode ?? */
		ftpwind;	/* is this an ftp window?? */
short slc[31];
	char
		TELstop,	/* Character for scrolling to stop */
		TELgo,		/* Character for scrolling to go */
		TELip,		/* Character for interrupt process */
	ftpbuf[MAXFTP],	/* BYU mod - Outgoing ftp commands buffer */
	kbbuf[MAXKB];	/* The keyboard buffer (echo mode ) */
	GrafPtr 
		  wind;
	};

typedef struct WindRec WindRec;
